/// <reference types="gapi.auth2" />
export declare type GoogleUserValue = {
    /**
     * Any error from loading the `GoogleUser` object
     */
    error: Error | null;
    /**
     * A `GoogleUser` object represents one user account.
     */
    currentUser: gapi.auth2.GoogleUser | null;
};
/**
 * A declarative wrapper around the `GoogleUser` object described here {@link https://developers.google.com/identity/sign-in/web/reference#users}. This automatically listens for changes to the `currentUser`
 * and updates the return value.
 *
 */
export declare const useGoogleUser: () => GoogleUserValue;
